import * as React from 'react';
import { History } from 'history';
import { ITranslations } from './types';
interface IProps {
    defaultLanguage?: string;
    languages: string[];
    translations: ITranslations;
    localizeUrls?: boolean;
    history?: History;
}
interface IState {
    language: string;
}
declare class LocaleProvider extends React.Component<IProps, IState> {
    state: {
        language: string;
    };
    componentDidMount(): void;
    private getIntialLanguage;
    private getBrowserLanguage;
    private getLanguageFromLocationState;
    private setLanguage;
    private getLanguageFromUrl;
    private insertLanguageToUrl;
    private updateUrl;
    private updateBrowserStorage;
    private handleError;
    private compareSearchedAndReplacedString;
    private replaceVars;
    private processVars;
    private performTranslation;
    private performTranslationAndParse;
    render(): JSX.Element | null;
}
export { LocaleProvider };
