"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalizedNavLink = void 0;
var React = require("react");
var react_router_dom_1 = require("react-router-dom");
var localizer_1 = require("./localizer");
var Translator_1 = require("./Translator");
var LocalizedNavLink = function (props) {
    var to = props.to, _a = props.localize, localize = _a === void 0 ? true : _a, rest = __rest(props, ["to", "localize"]);
    var getLocalizedUrl = function (language, url) {
        return localizer_1.getLocalizedRoute(language, url);
    };
    if (!localize) {
        return React.createElement(react_router_dom_1.NavLink, __assign({ to: to }, rest));
    }
    return (React.createElement(Translator_1.Translator, { render: function (language) {
            return React.createElement(react_router_dom_1.NavLink, __assign({ to: getLocalizedUrl(language, to) }, rest));
        } }));
};
exports.LocalizedNavLink = LocalizedNavLink;
