"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalizedRoute = void 0;
var React = require("react");
var react_router_dom_1 = require("react-router-dom");
var localizer_1 = require("./localizer");
var Translator_1 = require("./Translator");
var LocalizedRoute = function (props) {
    var children = props.children, Component = props.component, _a = props.localize, localize = _a === void 0 ? true : _a, render = props.render, exact = props.exact, path = props.path, rest = __rest(props, ["children", "component", "localize", "render", "exact", "path"]);
    var interceptHistory = function (history, language) {
        var push = function (pushedUrl) {
            var localizedUrl = localizer_1.getLocalizedRoute(language, pushedUrl);
            history.push(localizedUrl);
        };
        return __assign(__assign({}, history), { push: push });
    };
    var interceptProps = function (routeComponentProps, language) {
        return __assign(__assign({}, routeComponentProps), { history: interceptHistory(routeComponentProps.history, language) });
    };
    var getInterceptedPath = function () {
        if (path && localize) {
            return localizer_1.getLocalizedPath(path);
        }
        if (path) {
            return path;
        }
        return undefined;
    };
    return (React.createElement(Translator_1.Translator, { render: function (language) {
            return (React.createElement(react_router_dom_1.Route, __assign({ path: getInterceptedPath(), exact: exact, history: history, render: function (renderRouteProps) {
                    if (Component) {
                        return (React.createElement(Component, __assign({}, interceptProps(renderRouteProps, language))));
                    }
                    if (render) {
                        return render(interceptProps(renderRouteProps, language));
                    }
                    if (typeof children === 'function') {
                        return children(renderRouteProps);
                    }
                    return null;
                } }, rest)));
        } }));
};
exports.LocalizedRoute = LocalizedRoute;
