"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalizedRoutes = void 0;
var React = require("react");
var react_router_dom_1 = require("react-router-dom");
var LocalizedRedirect_1 = require("./LocalizedRedirect");
var LocalizedRoute_1 = require("./LocalizedRoute");
var localizer_1 = require("./localizer");
var Translator_1 = require("./Translator");
var LocalizedRoutes = function (props) {
    var _a = props.applySwitch, applySwitch = _a === void 0 ? false : _a, _b = props.routes, routes = _b === void 0 ? [] : _b, _c = props.localize, localizeRouteConfig = _c === void 0 ? true : _c;
    var getConfig = function (config) {
        return config.map(function (route, index) {
            var children = route.children, component = route.component, exact = route.exact, from = route.from, location = route.location, path = route.path, push = route.push, render = route.render, sensitive = route.sensitive, strict = route.strict, _a = route.localize, localize = _a === void 0 ? localizeRouteConfig === false ? false : true : _a, to = route.to, nestedRoutes = route.routes;
            var isRedirect = to ? true : false;
            var resolveRedirectFrom = function (language) {
                if (localize) {
                    return localizer_1.getLocalizedRoute(language, from);
                }
                if (localizeRouteConfig) {
                    return localizer_1.getLocalizedRoute(language, from);
                }
                return from;
            };
            var resolvePath = function () {
                if (localize) {
                    return localizer_1.getLocalizedPath(path);
                }
                if (localizeRouteConfig) {
                    return localizer_1.getLocalizedPath(path);
                }
                return path;
            };
            if (isRedirect) {
                return (React.createElement(React.Fragment, { key: index },
                    React.createElement(Translator_1.Translator, { render: function (language) { return (React.createElement(LocalizedRedirect_1.LocalizedRedirect, __assign({ from: resolveRedirectFrom(language), localize: localize === false ? false : localize || localizeRouteConfig }, { to: to, push: push, path: path, exact: exact, strict: strict }))); } })));
            }
            if (path || component || render) {
                return (React.createElement(LocalizedRoute_1.LocalizedRoute, __assign({ key: index, path: resolvePath() }, { children: children, location: location, render: render, sensitive: sensitive, component: component, exact: exact }), nestedRoutes && getConfig(nestedRoutes)));
            }
            return null;
        });
    };
    var routeConfig = getConfig(routes);
    if (applySwitch) {
        return React.createElement(react_router_dom_1.Switch, null, routeConfig);
    }
    return React.createElement(React.Fragment, null, routeConfig);
};
exports.LocalizedRoutes = LocalizedRoutes;
