"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useHistory = void 0;
var localizedHistory_1 = require("./localizedHistory");
var localizer_1 = require("./localizer");
var useTranslate_1 = require("./useTranslate");
var useHistory = function () {
    var language = useTranslate_1.useTranslate().language;
    var push = function (location) {
        var localizedUrl = localizer_1.getLocalizedRoute(language, location);
        localizedHistory_1.localizedHistory.push(localizedUrl);
    };
    var history = __assign(__assign({}, localizedHistory_1.localizedHistory), { push: push });
    return history;
};
exports.useHistory = useHistory;
